* FILE kfill
*
* Grace Version   1.00.00          MLIB.GRACE.V920425
************************************************************************
      SUBROUTINE KFILL(NEXTRN, ndim, X, PE, PP, ANS) 

      IMPLICIT REAL* 8(A-H,O-Z)

************************************************************************
      INTEGER NEXTRN 
      PARAMETER ( MXDIM = 50 )
      REAL*8  X(MXDIM) 
      REAL*8  PE(4,NEXTRN), PP(NEXTRN,NEXTRN) 
      COMMON/QPLIST/PLPTN(10,1000),NLPTN(10,1000),NTOP
      COMMON/QPKIM2/NADDPH(1000),NPHO,NADDMU(4),NMUO,nvph
      real*8 pb(4),pee(4,6)

      INCLUDE 'inclk.f'
      COMMON/KINEM1/S,W,FACT
      common/usrprm9/Pvis(4)
*=======================================================================
*          Fill Histograms and Scatter plots
*=======================================================================

           pb(1)=plptn(4,nvph)
           pb(2)=plptn(5,nvph)
           pb(3)=plptn(6,nvph)
           pb(4)=plptn(7,nvph)
        if(pb(1)**2+pb(2)**2+pb(3)**2 .lt. 1.d-10) then
           do 1 j=1,6
           do 1 i=1,4
            pee(i,j)=pe(i,j)
1          continue
        else
           do 2 i=1,6
2           call pboost(pe(1,i),pb, pee(1,i))
        end if

           p3=sqrt(pee(1,3)**2+pee(2,3)**2+pee(3,3)**2)
           p4=sqrt(pee(1,4)**2+pee(2,4)**2+pee(3,4)**2)
           p5=sqrt(pee(1,5)**2+pee(2,5)**2+pee(3,5)**2)
           CALL XHFILL(1,pee(4,3) , ANS )
           CALL XHFILL(2,pee(4,4) , ANS )
           CALL XHFILL(3,pee(4,5) , ANS )
	   cos3=pee(3,3)/sqrt(pee(1,3)**2+pee(2,3)**2+pee(3,3)**2)
           CALL XHFILL(4,cos3, ANS )
	   cos4=pee(3,4)/sqrt(pee(1,4)**2+pee(2,4)**2+pee(3,4)**2)
           CALL XHFILL(5,cos4, ANS )
	   cos5=pee(3,5)/sqrt(pee(1,5)**2+pee(2,5)**2+pee(3,5)**2)
           CALL XHFILL(6,cos5, ANS )
*-
           vm34 = sqrt(2.0d0*pp(3,4) + amass2(3) + amass2(4))
           vm35 = sqrt(2.0d0*pp(3,5) + amass2(3) + amass2(5))
           vm45 = sqrt(2.0d0*pp(4,5) + amass2(5) + amass2(4))
           CALL XHFILL(7,vm34, ANS )
           CALL XHFILL(8,vm35, ANS )
           CALL XHFILL(9,vm45, ANS )
*-
           cs34 = (pee(1,3)*pee(1,4)+pee(2,3)*pee(2,4)
     .+pee(3,3)*pee(3,4))/(p3*p4)
           cs35 = (pee(1,3)*pee(1,5)+pee(2,3)*pee(2,5)
     .+pee(3,3)*pee(3,5))/(p3*p5)
           cs45 = (pee(1,4)*pee(1,5)+pee(2,4)*pee(2,5)
     .+pee(3,4)*pee(3,5))/(p4*p5)
           CALL XHFILL(10,cs34, ANS )
           CALL XHFILL(11,cs35, ANS )
           CALL XHFILL(12,cs45, ANS )
*--
           
           ee=plptn(7,NADDMU(2))+plptn(7,NADDMU(3))
           px=plptn(4,NADDMU(2))+plptn(4,NADDMU(3))
           PY=plptn(5,NADDMU(2))+plptn(5,NADDMU(3))
           pz=plptn(6,NADDMU(2))+plptn(6,NADDMU(3))

           qq=sqrt(ee**2-px**2-py**2-pz**2)
           call xhfill(13,qq, ans)

           qz=pz
           call xhfill(14,qz, ans)

           qt=sqrt(px**2+py**2)
           call xhfill(15,qt, ans)

c          eph =plptn(7,NADDMU(1))
c          ptph=sqrt(plptn(4,NADDMU(1))**2+plptn(5,NADDMU(1))**2)
c          call xhfill(16,eph, ans)
c          call xhfill(17,ptph, ans)

           do 10 i=1,npho
            eph=plptn(7,NADDPH(i))
            ptph=sqrt(plptn(4,NADDPH(i))**2+plptn(5,NADDPH(i))**2)
            call xhfill(18,eph, ans) 
            call xhfill(19,ptph, ans) 
            call xhfill(16,eph, ans)
            call xhfill(17,ptph, ans)
10         continue

           anpho=npho+0.5d0
           call xhfill(20,anpho, ans)

           Pmisx= -Pvis(1)
           Pmisy= -Pvis(2)
           Pmisz= -Pvis(3)
           Pmise=W-Pvis(4)
           VMmiss=sqrt(Pmise**2-Pmisx**2-Pmisy**2-Pmisz**2)
           CALL XHFILL(21,VMmiss, ANS )
           CALL XHFILL(22,VMmiss, ANS )
      RETURN
      END
