************************************************************************
      SUBROUTINE ANWWAA(L1,L2,L3,L4,K1,K2,K3,K4,CPL,E1,E2,E3,E4
     &,                                           P1,P2,P3,P4,  LT,AV)
      IMPLICIT REAL*8(A-H,O-Z)
      PARAMETER (ZERO = 0.0D0, ONE = 1.0D0)
*   * dummy array size.
      PARAMETER (LTSIZE = 20, LASIZE = 1024)
      INTEGER    L1, L2, L3, L4
      COMPLEX*16 CPL
      DIMENSION  E1(4,L1), E2(4,L2), E3(4,L3), E4(4,L4)
      DIMENSION  P1(4),P2(4),P3(4),P4(4)
      DIMENSION  Pi1(4),Pi2(4),Pi3(4),Pi4(4)
      COMPLEX*16 AV(0:LASIZE)
*     COMPLEX*16 AV(0:L2*L1-1)
      INTEGER    LT(0:LTSIZE)
* for anomalous TGC added by YK
      common /anotgc/k0b,k0w,k0m,kcb,kcw,kcm,
     .               k1b,k1w,k1m,k2b,k2w,k2m,k3b,k3w,k3m,
     .               gcos,gsin
      real*8 k0b,k0w,k0m,kcb,kcw,kcm,k1b,k1w,k1m,k2b,k2w,k2m
      real*8 k3b,k3w,k3m
*
*-----------------------------------------------------------------------
      LT(0) = 4
      LT(1) = L1
      LT(2) = L2
      LT(3) = L3
      LT(4) = L4

* set momentum in-coming
      do 1 I=1,4
       Pi1(I)=P1(I)*k1
       Pi2(I)=P2(I)*k2
       Pi3(I)=P3(I)*k3
       Pi4(I)=P4(I)*k4
1     continue
*
* anomalous 
*
      anf0=(K0w+K0b+K0m)
      anfc=(Kcw+Kcb+Kcm)
      IA = 0
      DO 600 IL4 = 1, L4
      DO 600 IL3 = 1, L3
      DO 600 IL2 = 1, L2
      DO 600 IL1 = 1, L1
        CALL VVVV_p0(1.0D0,E1(1,IL1),E2(1,IL2),E3(1,IL3),E4(1,IL4)
     &,                    Pi1       ,Pi2       ,Pi3       ,Pi4
     &,AV0)
        AV(IA) = CPL*2*AV0*anf0
        CALL VVVV_pc(1.0D0,E1(1,IL1),E2(1,IL2),E3(1,IL3),E4(1,IL4)
     &,                    Pi1       ,Pi2       ,Pi3       ,Pi4
     &,AVc)
        AV(IA) = AV(IA)+CPL*AVc*anfc/2.d0

        IA = IA + 1
  600 CONTINUE

      RETURN
      END
