* FILE kfill
*
* Grace Version   1.00.00          MLIB.GRACE.V920425
************************************************************************
      SUBROUTINE KFILL(NEXTRN, ndim, X, PE, PP, ANS) 

      IMPLICIT REAL* 8(A-H,O-Z)

************************************************************************
      INTEGER NEXTRN 
      PARAMETER ( MXDIM = 50 )
      REAL*8  X(MXDIM) 
      REAL*8  PE(4,NEXTRN), PP(NEXTRN,NEXTRN) 

      INCLUDE 'inclk.h'
      COMMON/QPLIST/PLPTN(10,1000),NLPTN(10,1000),NTOP
      COMMON/CUTQP /IQEDPS,NOBPHO,COSPHO,EPHOCT,COSOPN
      COMMON/KINEM2/Q2,NADDPH(1000),NPHO,nvph,NADDMU(100),NMUO

      COMMON/KINEM1/S,W,FACT
      common/usrprm9/Pvis(4)

      real*8 pb(4),pee(4,6)
*=======================================================================
*          Fill Histograms and Scatter plots
*=======================================================================

c       DO 40 I = 1, NDIM
c          CALL XHFILL( I, X(I), ANS )
c  40   CONTINUE
     
           pb(1)=plptn(4,nvph)
           pb(2)=plptn(5,nvph)
           pb(3)=plptn(6,nvph)
           pb(4)=plptn(7,nvph)
        if(pb(1)**2+pb(2)**2+pb(3)**2 .lt. 1.d-10) then
           do 1 j=1,6
           do 1 i=1,4
            pee(i,j)=pe(i,j)
1          continue
        else
           do 2 i=1,6
2           call pboost(pe(1,i),pb, pee(1,i))
        end if

           CALL XHFILL(1,pee(4,3) , ANS )
           CALL XHFILL(2,pee(4,4) , ANS )
           CALL XHFILL(3,pee(4,5) , ANS )
           CALL XHFILL(4,pee(4,6) , ANS )

	   cos3=pee(3,3)/sqrt(pee(1,3)**2+pee(2,3)**2+pee(3,3)**2)
           CALL XHFILL(5,cos3, ANS )
	   cos4=pee(3,4)/sqrt(pee(1,4)**2+pee(2,4)**2+pee(3,4)**2)
           CALL XHFILL(6,cos4, ANS )
	   cos5=pee(3,5)/sqrt(pee(1,5)**2+pee(2,5)**2+pee(3,5)**2)
           CALL XHFILL(7,cos5, ANS )
	   cos6=pee(3,6)/sqrt(pee(1,6)**2+pee(2,6)**2+pee(3,6)**2)
           CALL XHFILL(8,cos6, ANS )

*--
           
           ee=plptn(7,NADDMU(4))+plptn(7,NADDMU(3))
           px=plptn(4,NADDMU(4))+plptn(4,NADDMU(3))
           py=plptn(5,NADDMU(4))+plptn(5,NADDMU(3))
           pz=plptn(6,NADDMU(4))+plptn(6,NADDMU(3))

           qq=sqrt(ee**2-px**2-py**2-pz**2)
           call xhfill(10,qq, ans)

           qz=pz
           call xhfill(11,qz, ans)

           qt=sqrt(px**2+py**2)
           call xhfill(12,qt, ans)


           do 10 i=1,npho
            eph=plptn(7,NADDPH(i))
            ptph=sqrt(plptn(4,NADDPH(i))**2+plptn(5,NADDPH(i))**2)
            call xhfill(13,eph, ans) 
            call xhfill(14,ptph, ans) 
10         continue


           Pmisx= -Pvis(1)
           Pmisy= -Pvis(2)
           Pmisz= -Pvis(3)
           Pmise=W-Pvis(4)
           VMmiss=sqrt(Pmise**2-Pmisx**2-Pmisy**2-Pmisz**2)
           CALL XHFILL(21,VMmiss, ANS )
           CALL XHFILL(22,VMmiss, ANS )
      RETURN
      END
