      SUBROUTINE KINEM(NEXTRN,X,PE,PP,YACOB,NREG,IREG,JUMP)
 
C---------------------------------------------------------------------
C   GRACE System Library File
C   KINEM No. : 4003
C   Date      : 1994.04.30
C   Author    : Y.Kurihara
C---------------------------------------------------------------------
      IMPLICIT REAL* 8(A-H,O-Z)
************************************************************************
      INTEGER NEXTRN
      PARAMETER ( MXDIM = 50 )
 
      COMMON / BASE1 / XL(MXDIM),XU(MXDIM),NDIM
      REAL*8  X(MXDIM)
      REAL*8  PE(4,NEXTRN), PP(NEXTRN,NEXTRN)
      REAL*8  YACOB
      INTEGER NREG, IREG
      INTEGER JUMP
 
      INCLUDE 'inclk.h'
*--------------------------------------------------------------------
      COMMON/KMCNTL/IRESNS,Idummy,ICOS3,ICOS4
      COMMON/KINEM1/S1,W1,FACT
      COMMON/CUT001/COSCUT(2,4),ENGYCT(2,4),adummy(2),
     .AMASCT(2),adumy2(2),ARESNS(2)      
      DIMENSION PBSTCL(4),PBSTLC(4),ROTCL(3,3),ROTLC(3,3)
      DIMENSION Q1L(4),Q2L(4),Q1C(4)
      real*8 ptemp(4),plc(4),vmax(2)
      real*8 EBps(2),PBps(2)
*- QEDPS ------------------------------------------------------------
      COMMON/QPLIST/PLPTN(10,1000),NLPTN(10,1000),NTOP
      COMMON/CUTQP /IQEDPS,NOBPHO,COSPHO,EPHOCT,COSOPN
      COMMON/KINEM2/Q2,NADDPH(1000),NPHO,nvph,NADDMU(100),NMUO
      common/QPRNDM/xrnd(101),ipnt,irdmax
      data nnnn/0/
*-----------------------------------------------------------------------
      BETA(Z1,Z2)=SQRT(1-2*(Z1+Z2)+(Z1-Z2)**2)
      NREG   =   1
      JUMP   =   0
      YACOB  =   0.D0
      AJACOB=    1
* Set integration variables
       if(iqedps.eq.1) then
       do 100 irnd=1,irdmax-1
c       xrnd(irnd)=x(irnd)
        xrnd(irnd)=QPRAND( IDUM  )
100    continue
       xrnd(irdmax)=1.d0
       ipnt=1
       CALL QPINT(iok)
       IF(iOK.EQ.0) write(6,*)' iok ',iok
       IF(iOK.EQ.0) GOTO 999
       CALL QPANNH(qQ2,NOK)
       IF(NOK.EQ.0) GOTO 999
       NVPH = NTOP
       CALL QPFNL(NVPH,pe,iok)
       IF(iOK.EQ.0) GOTO 999
       S=qQ2
       w=sqrt(s)

C CUTS FOR PS-PHOTONs from initial state

      NPHO=0
      NMUO=0

      NVISps=0
      NIVPps=0
      NSOFps=0
      DO 3 I=1,NTOP
       IF(ABS(NLPTN(1,I)).NE.0 .OR.NLPTN(3,I).NE.0)GOTO 3
       COSPH=PLPTN(6,I)/PLPTN(7,I)
       IF(PLPTN(7,I).GE.EPHOCT) THEN
* hard photon
        IF(ABS(COSPH).LE.COSPHO) THEN
* Visible photon
         NPHO=NPHO+1
         NVISps=NVISps+1
         NMUO=NMUO+1
         NADDPH(NPHO)=I
         NADDMU(NMUO)=I
         ptp=sqrt(plptn(4,i)**2+plptn(5,i)**2)
        ELSE
* Invisible photon
         NIVPps=NIVPps+1
        END IF
       ELSE
* Soft photon
        NSOFps=NSOFps+1
       END IF
3     CONTINUE
* Statistic factor for Radiative processes.
c     IF(NOBPHO.GE.0 .AND. NPHO.NE.NOBPHO) GOTO 999
      IF(NOBPHO.GE.0 .AND. NPHO.gt.NOBPHO) GOTO 999
c     IF(NOBPHO.GE.0 .AND. NPHO.gt.  1   ) GOTO 999

       plc(1)=-plptn(4,nvph)
       plc(2)=-plptn(5,nvph)
       plc(3)=-plptn(6,nvph)
       plc(4)= plptn(7,nvph)
       psum=sqrt(plptn(4,nvph)**2
     . +         plptn(5,nvph)**2
     . +         plptn(6,nvph)**2)
       if(psum.gt.0) then
        if(NPHO.eq.0) then
         eamin=1.d-3
        else
         eamin=1.d-8
        end if
        ptemp(1)=eamin*plptn(4,nvph)/psum
        ptemp(2)=eamin*plptn(5,nvph)/psum
        ptemp(3)=eamin*plptn(6,nvph)/psum
        ptemp(4)=eamin
        call pboost(ptemp,plc, ptemp)
        eamin1=ptemp(4)
        eamin=engyct(1,2)
        ptemp(1)=eamin*plptn(4,nvph)/psum
        ptemp(2)=eamin*plptn(5,nvph)/psum
        ptemp(3)=eamin*plptn(6,nvph)/psum
        ptemp(4)=eamin
        call pboost(ptemp,plc, ptemp)
        eamin2=ptemp(4)
       else
        eamin1=engyct(1,1)
        eamin2=engyct(1,2)
       end if

       else
        S=s1
        w=sqrt(s)
        eamin1=engyct(1,1)
        eamin2=engyct(1,2)
       end if



      E1      = (S+AMASS2(1)-AMASS2(2))/2.D0/W
      E2      = (S+AMASS2(2)-AMASS2(1))/2.D0/W
*******
* Q10 *
*******
       Q10MIN=MAX((AMASS2(1)-AMASS2(2)+
     . (AMASS1(4)+AMASCT(1))**2-AMASS2(3))/2.D0/W
     .,        E1-engyct(2,1))
       Q10MAX= E1-eamin1
       IF     (ICOS3.EQ.0) THEN
        Q10=Q10MIN+(Q10MAX-Q10MIN)*X(1)
                      AJACOB=AJACOB*(Q10MAX-Q10MIN)
       ELSE IF(ICOS3.EQ.1) THEN
        Q10=Q10MIN*(Q10MAX/Q10MIN)**X(1)
                      AJACOB=AJACOB*Q10*LOG(Q10MAX/Q10MIN)
        q10=q10max-q10
       ELSE
        GOTO 999
       END IF
       P30=E1-Q10
*******
* Q20 *
*******
      SH=AMASCT(1)**2
c     A=2*Q10*W+AMASS2(3)
c     B=(4*Q10**2*S+2*Q10*W*(AMASS2(4)+AMASS2(3)-S-SH)+SH*(
c    1 AMASS2(4)-AMASS2(3)-S))/(2.D0*W)
c     C=(4*Q10**2*AMASS2(4)*S+2*Q10*W*SH*(-AMASS2(4)+AMASS2(3)
c    1 -S)+SH*(AMASS2(4)**2-2*AMASS2(4)*AMASS2(3)-2*AMASS2(4)*
c    2 S+AMASS2(3)**2-2*AMASS2(3)*S+S**2+S*SH))/(4.D0*S)
c      D=B**2-4*A*C
c      IF(D.LT.0)THEN
c       Q20MIN=-1.d10
c      ELSE
c       Q20MIN=(-B-SQRT(D))/2.D0/A
c      END IF
c      Q20MIN=MAX(Q20MIN,E2-ENGYCT(2,2))
       Q20MIN=MAX((AMASS2(2)-AMASS2(1)+
     . (AMASS1(3)+AMASCT(1))**2-AMASS2(4))/2.D0/W
     .,                  E2-ENGYCT(2,2))
       Q20MAX=           E2-eamin2
       IF     (ICOS4.EQ.0) THEN
        Q20=Q20MIN+(Q20MAX-Q20MIN)*X(2)
                      AJACOB=AJACOB*(Q20MAX-Q20MIN)
       ELSE IF(ICOS4.EQ.1) THEN
        Q20=Q20MIN*(Q20MAX/Q20MIN)**X(2)
                      AJACOB=AJACOB*Q20*LOG(Q20MAX/Q20MIN)
        q20=q20max-q20
       ELSE
        GOTO 999
       END IF
       P40=E2-Q20
*******
* Q12 *
*******
       BET1=SQRT( (E1 +AMASS1(1))*(E1 -AMASS1(1)) )/E1
       PEF3=SQRT( (P30+AMASS1(3))*(P30-AMASS1(3)) )
       BET3=SQRT( (P30+AMASS1(3))*(P30-AMASS1(3)) )/P30
       Q12MAX=2*E1*(P30+BET1*PEF3)
       Q12MIN=2*E1*(P30-BET1*PEF3)
       IF     (ICOS3.EQ.0) THEN
        Q12=Q12MIN+(Q12MAX-Q12MIN)*X(3)
                      AJACOB=AJACOB*(Q12MAX-Q12MIN)
       ELSE IF(ICOS3.EQ.1) THEN
        Q12=Q12MIN*(Q12MAX/Q12MIN)**X(3)
                      AJACOB=AJACOB*Q12*LOG(Q12MAX/Q12MIN)
       ELSE
        GOTO 999
       END IF
       q12=q12-AMASS2(1)-AMASS2(3)
       if(q12.le.0) goto 999
*******
* Q22 *
*******
       BET2=SQRT( (E2 +AMASS1(2))*(E2 -AMASS1(2)) )/E2
       PEF4=SQRT( (P40+AMASS1(4))*(P40-AMASS1(4)) )
       BET4=SQRT( (P40+AMASS1(4))*(P40-AMASS1(4)) )/P40
       Q22MAX=2*E2*(P40+BET2*PEF4)
       Q22MIN=2*E2*(P40-BET2*PEF4)
       IF     (ICOS4.EQ.0) THEN
        Q22=Q22MIN+(Q22MAX-Q22MIN)*X(4)
                      AJACOB=AJACOB*(Q22MAX-Q22MIN)
       ELSE IF(ICOS4.EQ.1) THEN
        Q22=Q22MIN*(Q22MAX/Q22MIN)**X(4)
                      AJACOB=AJACOB*Q22*LOG(Q22MAX/Q22MIN)
       ELSE
        GOTO 999
       END IF
       q22=q22-AMASS2(2)-AMASS2(4)
       if(q22.le.0) goto 999
******** 
* PHI3 * 
******** 
c      IF(NDIM.EQ.8) THEN
        PHI3=X(8)*2*PI
c      ELSE
c       PHI3=0
c      END IF
                     AJACOB=AJACOB*2*PI
************************
* COS5 in 5-6 CM frame *
************************
       COS5=-1+2*X(5)
       SIN5=SQRT( (1-COS5)*(1+COS5) )
                     AJACOB=AJACOB*2
************************
* PHI5 in 5-6 CM frame *
************************
       PHI5=X(6)*2*PI+PHI3
                     AJACOB=AJACOB*2*PI
**************
* COS3, SIN3 *
**************
       GAM3= BET1*BET3
       ALP3= 1-(AMASS2(1)+AMASS2(3))/2.D0/E1/P30
       COS3= (ALP3-Q12/2.D0/E1/P30)/GAM3
c      if(abs(cos3).gt.1)goto 999
       if(abs(cos3).gt.1)cos3=sign(1.d0,cos3)
       SIN3= SQRT( (1-COS3)*(1+COS3) )
**************
* COS4, SIN4 *
**************
       GAM4= BET2*BET4
       ALP4= 1-(AMASS2(2)+AMASS2(4))/2.D0/E2/P40
       COS4=-(ALP4-Q22/2.D0/E2/P40)/GAM4
c      if(abs(cos4).gt.1)goto 999
       if(abs(cos4).gt.1)cos4=sign(1.d0,cos4)
       SIN4= SQRT( (1-COS4)*(1+COS4) )
******
* SH *
******
       DDDD=  1+(1+AMASS2(1)/BET1/(1+BET1)/E1/E1)
     .*         (1-(AMASS2(1)+AMASS2(3)+Q12)/2.D0/E1/P30)
     .*         (1+AMASS2(2)/BET2/(1+BET2)/E2/E2)
     .*         (1-(AMASS2(2)+AMASS2(4)+Q22)/2.D0/E2/P40)
       PSI0=S-2*W*(P30+P40)+2*P30*P40*DDDD+AMASS2(3)+AMASS2(4)
       OMEGA=2*PEF3*PEF4*SIN3*SIN4
       SHMIN=MAX((  AMASS1(5)+AMASS1(6))**2,PSI0-OMEGA,AMASCT(1)**2)
       SHMAX=MIN((W-AMASS1(3)-AMASS1(4))**2,PSI0+OMEGA,AMASCT(2)**2)
      IF(SHMAX.LT.SHMIN) GOTO 999
      IF     (IRESNS.EQ. 0) THEN
       SH  = SHMIN+(SHMAX-SHMIN)*X(7)
                 AJACOB = AJACOB*(SHMAX-SHMIN)
      ELSE IF(IRESNS.EQ.-1) THEN
       SH  = SHMIN*(SHMAX/SHMIN)**X(7)
                 AJACOB = AJACOB*SH*LOG(SHMAX/SHMIN)
      ELSE IF(IRESNS.EQ. 1) THEN
       AM    = ARESNS(1)
       AM2   =AM*AM
       AMG   =ARESNS(1)*ARESNS(2)
       THEMIN=ATAN((SHMIN-AM2)/AMG)
       THEMAX=ATAN((SHMAX-AM2)/AMG)
       THE   =THEMIN+(THEMAX-THEMIN)*X(7)
       SH    =AMG*TAN(THE)+AM2
                 AJACOB=AJACOB*(THEMAX-THEMIN)
     .*                 ((SH-AM2)**2+AMG**2)/AMG
      ELSE
       GOTO 999
      END IF
*******
* PHI *
*******
      PSI=PSI0-SH
      IF(OMEGA    .EQ.0) GOTO 999
      COSP=PSI/OMEGA
      IF(ABS(COSP).GT.1) GOTO 999
      sinp=sqrt( (1-cosp)*(1+cosp) )
      phi4=atan2(sinp,cosp)+phi3
                 AJACOB=AJACOB*2
* Set four-vectors
*Particle 1
      P1      = SQRT( (E1-AMASS1(1))*(E1+AMASS1(1)) )
      PE(1,1) = 0
      PE(2,1) = 0
      PE(3,1) = P1
      PE(4,1) = E1
 
*Particle 2
      P2      = SQRT( (E2-AMASS1(2))*(E2+AMASS1(2)) )
      PE(1,2) = 0
      PE(2,2) = 0
      PE(3,2) =-P2
      PE(4,2) = E2
 
*Particle 3
      PE(1,3) = PEF3*SIN3*COS(PHI3)
      PE(2,3) = PEF3*SIN3*SIN(PHI3)
      PE(3,3) = PEF3*COS3
      PE(4,3) = P30
 
*Particle 4
      PE(1,4) = PEF4*SIN4*COS(PHI4)
      PE(2,4) = PEF4*SIN4*SIN(PHI4)
      PE(3,4) = PEF4*COS4
      PE(4,4) = P40
 
*Particle 5 in 5-6 CM frame
      E5      = (SH+AMASS2(5)-AMASS2(6))/2.D0/SQRT(SH)
      P5      = SQRT( (E5-AMASS1(5))*(E5+AMASS1(5)) )
      PE(1,5) = P5*SIN5*COS(PHI5)
      PE(2,5) = P5*SIN5*SIN(PHI5)
      PE(3,5) = P5*COS5
      PE(4,5) = E5
 
*Particle 6 in 5-6 CM frame
      E6      = (SH+AMASS2(6)-AMASS2(5))/2.D0/SQRT(SH)
      PE(1,6) =-PE(1,5)
      PE(2,6) =-PE(2,5)
      PE(3,6) =-PE(3,5)
      PE(4,6) = E6
* Q1 Q2
       Q1L(1)=PE(1,1)-PE(1,3)
       Q1L(2)=PE(2,1)-PE(2,3)
       Q1L(3)=PE(3,1)-PE(3,3)
       Q1L(4)=PE(4,1)-PE(4,3)
 
       Q2L(1)=PE(1,2)-PE(1,4)
       Q2L(2)=PE(2,2)-PE(2,4)
       Q2L(3)=PE(3,2)-PE(3,4)
       Q2L(4)=PE(4,2)-PE(4,4)
 
       PBSTCL(1)= Q1L(1)+Q2L(1)
       PBSTCL(2)= Q1L(2)+Q2L(2)
       PBSTCL(3)= Q1L(3)+Q2L(3)
       PBSTCL(4)= Q1L(4)+Q2L(4)
 
       PBSTLC(1)=-Q1L(1)-Q2L(1)
       PBSTLC(2)=-Q1L(2)-Q2L(2)
       PBSTLC(3)=-Q1L(3)-Q2L(3)
       PBSTLC(4)= Q1L(4)+Q2L(4)
 
C DETERMIN ROTATION MATRICES
       CALL PBOOST(Q1L,PBSTLC,Q1C)
       CALL ROTMTX(Q1C, ROTLC)
       CALL MINVR2(ROTLC,ROTCL)
 
*Particle 5 in 1-2 CM frame (Lab-frame)
       CALL MVMULT(ROTCL,PE(1,5),PE(1,5))
       CALL PBOOST(PE(1,5),PBSTCL,PE(1,5))
*Particle 6 in 1-2 CM frame (Lab-frame)
       CALL MVMULT(ROTCL,PE(1,6),PE(1,6))
       CALL PBOOST(PE(1,6),PBSTCL,PE(1,6))
 
*Set invariants
      DO 1 I1=1,6
      DO 1 J1=1,6
1      PP(I1,J1)=PE(4,I1)*PE(4,J1)
     .-          PE(1,I1)*PE(1,J1)
     .-          PE(2,I1)*PE(2,J1)
     .-          PE(3,I1)*PE(3,J1)
      PP(1,2) = (S  -AMASS2(1)-AMASS2(2))/2.D0
      PP(2,1) = (S  -AMASS2(1)-AMASS2(2))/2.D0
      PP(1,3) = (Q12+AMASS2(1)+AMASS2(3))/2.D0
      PP(3,1) = (Q12+AMASS2(1)+AMASS2(3))/2.D0
      PP(2,4) = (Q22+AMASS2(2)+AMASS2(4))/2.D0
      PP(4,2) = (Q22+AMASS2(2)+AMASS2(4))/2.D0
      PP(5,6) = (SH -AMASS2(5)-AMASS2(6))/2.D0
      PP(6,5) = (SH -AMASS2(5)-AMASS2(6))/2.D0

* cuts in Lab-frame

      if(iqedps.eq.1) then
** QEDPS start *****************************************************
       CALL QPFNL2(NVPH,pe,iok)
       IF(iOK.EQ.0) GOTO 999
       CALL QPRTF2(nvph,pe)
       CALL QPBSFL(NVPH)

c     if(nnnn.le.20) then
c      CALL QPDUMP
c      CALL QPpchk
c      NNNN=NNNN+1
c     else
c      stop
c     end if
 
*********** virtuality check *******************************
       tt1=amass2(3)+amass2(1)-2.d0*pp(1,3)
       tt2=amass2(3)+amass2(2)-2.d0*pp(2,3)
       tt3=amass2(4)+amass2(1)-2.d0*pp(1,4)
       tt4=amass2(4)+amass2(2)-2.d0*pp(2,4)

        vmax(1)=999.
        vmax(2)=999.
        do 8 i=1,ntop 
         if(nlptn(1,i).le.2 .and. plptn(2,i).lt.0.d0)
     .     vmax(nlptn(1,i))=min(vmax(nlptn(1,i)),plptn(2,i))
8       continue

      if(tt1.gt.vmax(1)) goto 999
      if(tt2.gt.vmax(2)) goto 999
      if(tt3.gt.vmax(1)) goto 999
      if(tt4.gt.vmax(2)) goto 999
C CUTS FOR final particles
      NVISme=0
      NIVPme=0
      NSOFme=0
      DO 2 I=1,NTOP
       IF(NLPTN(3,I).NE.0)GOTO 2
       IF(NLPTN(1,I).LE.2) then
        IF(NLPTN(1,I).gt.0) then
         if(plptn(7,i).lt.amass1(nlptn(1,i))) then
          goto 999
         end if
         EBps(NLPTN(1,I))=PLPTN(7,I)
         PBps(NLPTN(1,I))=sqrt(PLPTN(7,I)**2-amass2(NLPTN(1,I)))
        end if
       else
        COSMU=PLPTN(6,I)
     ./  SQRT(PLPTN(4,I)**2+PLPTN(5,I)**2+PLPTN(6,I)**2)
*
        id=nlptn(1,i)-2
        if(id.eq.1 .or. id.eq.2)then
          if(plptn(7,i).gt.engyct(1,id))then
           if(abs(cosmu).lt.coscut(2,id)) then
             NPHO=NPHO+1
             NADDPH(NPHO)=I
             NMUO=NMUO+1
             NADDMU(NMUO)=I
             NVISme=NVISme+1
           else
             NIVPme=NIVPme+1
           end if
          else
             NSOFme=NSOFme+1
          end if
           ptpm=sqrt(plptn(4,i)**2+plptn(5,i)**2)
           goto 2
        end if
*
        IF(PLPTN(7,I).LT.engyct(1,id)) GOTO 999
        IF(PLPTN(7,I).gT.engyct(2,id)) GOTO 999
        IF(COSMU.LT.COScut(1,id)) GOTO 999
        IF(COSMU.GT.COScut(2,id)) GOTO 999
        NMUO=NMUO+1
        NADDMU(NMUO)=I
       end if
2     CONTINUE
      if(NPHO.ne.2) goto 999
      if(NVISme.ne.2) then
*                                if(NSOFme.ne.0) goto 999
*                                if(NIVPps.ne.0) goto 999
      if     (vmax(1).lt.0 .and. vmax(2).lt.0) then
          Epmin=min(
     .              (-vmax(1)+amass2(1))/2.d0/(EBps(1)+PBps(1))
     .,             (-vmax(2)+amass2(2))/2.d0/(EBps(2)+PBps(2)) )
         else if(vmax(1).lt.0 .and. vmax(2).gt.0) then
          Epmin=(-vmax(1)+amass2(1))/2.d0/(EBps(1)+PBps(1))
         else if(vmax(1).gt.0 .and. vmax(2).lt.0) then
          Epmin=(-vmax(2)+amass2(2))/2.d0/(EBps(2)+PBps(2))
         else
          Epmin = 0
         end if
         Npsp=0
         DO 4 I=1,NTOP
          IF(NLPTN(1,I).NE.0 .OR.NLPTN(3,I).NE.0)GOTO 4
          IF(PLPTN(7,I).GE.Epmin) Npsp=Npsp+1
4        continue
         ajacob=ajacob/dble(Npsp+NIVPme)
c        ajacob=ajacob/(NIVPps+NVISps+NIVPme)
c        ajacob=ajacob/(NIVPps+NVISps+NSOFps+NIVPme)
        end if
*
** QEDPS END********************************************************
       else
        COS3LB=PE(3,3)/SQRT(PE(1,3)**2+PE(2,3)**2+PE(3,3)**2)
        IF(COS3LB.LT.COSCUT(1,1) .OR. COS3LB.GT.COSCUT(2,1)) GOTO 999
        COS4LB=PE(3,4)/SQRT(PE(1,4)**2+PE(2,4)**2+PE(3,4)**2)
        IF(COS4LB.LT.COSCUT(1,2) .OR. COS4LB.GT.COSCUT(2,2)) GOTO 999
        COS5LB=PE(3,5)/SQRT(PE(1,5)**2+PE(2,5)**2+PE(3,5)**2)
        IF(COS5LB.LT.COSCUT(1,3) .OR. COS5LB.GT.COSCUT(2,3)) GOTO 999
        COS6LB=PE(3,6)/SQRT(PE(1,6)**2+PE(2,6)**2+PE(3,6)**2)
        IF(COS6LB.LT.COSCUT(1,4) .OR. COS6LB.GT.COSCUT(2,4)) GOTO 999

        IF(PE(4,3).LT.ENGYCT(1,1).OR.PE(4,3).GT.ENGYCT(2,1)) GOTO 999
        IF(PE(4,4).LT.ENGYCT(1,2).OR.PE(4,4).GT.ENGYCT(2,2)) GOTO 999
        IF(PE(4,5).LT.ENGYCT(1,3).OR.PE(4,5).GT.ENGYCT(2,3)) GOTO 999
        IF(PE(4,6).LT.ENGYCT(1,4).OR.PE(4,6).GT.ENGYCT(2,4)) GOTO 999


        npho=0
        nmuo=3
        ntop=6
        do 1919 i=1,ntop
         nlptn(1,i)=1
         nlptn(3,i)=0
         plptn(4,i)=pe(1,i)
         plptn(5,i)=pe(2,i)
         plptn(6,i)=pe(3,i)
         plptn(7,i)=pe(4,i)
         if(i.ge.3)NADDMU(i-2)=I
1919    continue
        nvph=7
        plptn(4,nvph)=0
        plptn(5,nvph)=0
        plptn(6,nvph)=0
        plptn(7,nvph)=w
       end if
*Set jacobian
      YACOB=FACT*AJACOB*s1/s
     ./32/PI2 * BETA(AMASS2(5)/SH,AMASS2(6)/SH)
     ./16/(2*PI)**6/BET1/BET2/E1/E2/SQRT( (OMEGA-PSI)*(OMEGA+PSI) )
c    .*(1+7.2973531d-3/pi*(pi2/3.d0-0.5d0))
*********** DEBUG **********************************
c     WRITE(6,*)'*****************************'
c     WRITE(6,'(6(4E13.4/))')PE
c     WRITE(6,*)'*****************************'
c     WRITE(6,'(6(6E13.4/))')PP
c     WRITE(6,*)' YACOB ',YACOB
c     WRITE(6,*)' TOTAL ENERGY INI   ',PE(4,1)+PE(4,2)
c     WRITE(6,*)' TOTAL ENERGY FINAL ',PE(4,3)+PE(4,4)
c    .+                                PE(4,5)+PE(4,6)
c     WRITE(6,'(6E13.4)')(SQRT(PP(KKK,KKK)),KKK=1,6)
c     WRITE(6,*)' INITIAL '
c     WRITE(6,*)' PX ',PE(1,1)+PE(1,2)
c     WRITE(6,*)' PY ',PE(2,1)+PE(2,2)
c     WRITE(6,*)' PZ ',PE(3,1)+PE(3,2)
c     WRITE(6,*)' FINAL   '
c     WRITE(6,*)' PX ',PE(1,3)+PE(1,4)+PE(1,5)+PE(1,6)
c     WRITE(6,*)' PY ',PE(2,3)+PE(2,4)+PE(2,5)+PE(2,6)
c     WRITE(6,*)' PZ ',PE(3,3)+PE(3,4)+PE(3,5)+PE(3,6)
*********** DEBUG **********************************
      RETURN
999   CONTINUE
      JUMP=1
      RETURN
      END
      subroutine kinemp(ireg)
      IMPLICIT REAL* 8(A-H,O-Z)

      return
      end
